#define WIN_INCLUDEALL

#include once "windows.bi"
#include "fbgfx.bi"


function file_getname( byval hWnd as HWND ) as string

        dim ofn as OPENFILENAME
        dim filen as zstring * MAX_PATH+1
        dim filemask as string
        
        filemask = "BMP Files, (*.BMP)"+chr$(0)+"*.BMP"+chr$(0)+chr$(0)
        with ofn
                .lStructSize           = sizeof( OPENFILENAME )
                .hwndOwner             = hWnd
                .hInstance             = GetModuleHandle( NULL )
                .lpstrFilter           = strptr( filemask )
                .lpstrCustomFilter     = NULL
                .nMaxCustFilter        = 0
                .nFilterIndex          = 1
                .lpstrFile             = @filen
                .nMaxFile              = sizeof( filen )
                .lpstrFileTitle        = NULL
                .nMaxFileTitle         = 0
                .lpstrInitialDir       = NULL
                .lpstrTitle            = @"Select BMP File to Process..."
                .Flags                 = OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST
                .nFileOffset           = 0
                .nFileExtension        = 0
                .lpstrDefExt           = NULL
                .lCustData             = 0
                .lpfnHook              = NULL
                .lpTemplateName        = NULL
        end with
        
        if( GetOpenFileName( @ofn ) = FALSE ) then
                return ""
        else
                return filen
        end if

end Function

DIM image(320, 192) as Integer, apal(15,3), imz(320,192,3), charo(8, 8,3), COLL(16), codis(16, 16), outbmp(320, 192), outcol(40, 24, 2), collok(16), FOUTCHAR(960), FOUTFORE(960), FOUTBACK(960)
DIM imgload(320*192) AS Integer, charmap(511,7,7), matches(255,255), imagein(320,192,3) as Integer, imout(319,191), imageinbak(320,192,3) as Integer
Dim ret As String, graphchar(255),gpal(3,3), mixcharo(8,8,3) as integer, outchars(40, 24,2) as integer, outchar(40,24), mixpals(15,15,15,15,4,3) as Integer,charoout(8,8,3)
DIM ImageOut(320,192,3),mixedpal(15,15,3),palcount(40,24,15,15),palout(40,24,4)

Screenres 1000,900,32: CLS
LOCATE 1, 1
FILENAME$ = "-"
TOGGLE = 0

filename$=file_getname(NULL)

for t=1 to len(filename$)
    if mid(filename$,t,1)="\" then positionslash=t
next t

SAVENAME$=left$(right$(filename$,len(filename$)-positionslash),len(right$(filename$,len(filename$)-positionslash))-4)



rem PRINT "Loading Color Distance Table"

FOR i = 1 TO 16
  FOR j = 1 TO 16
     READ codis(i, j)
     'LOCATE 2, 1: PRINT "Index "; i; j
  NEXT j
NEXT i

LOCATE 3, 1

rem PRINT "Loading Color Lookup Table"

FOR i = 0 TO 15

  READ collok(i)
  'LOCATE 4, 1: PRINT "Color "; i; collok(i)
NEXT i

for i = 0 to 255
 read lin$
 for j=0 to 7
    for p=0 to 7
      charmap(i,p,j)=val(mid$(lin$,p+j*8+1,1))
      if val(mid$(lin$,p+j*8+1,1))=0 then charmap(i+256,p,j)=1 else charmap(i+256,p,j)=0
    next p
 next j    
next i

for j=0 to 15
   read apal(j,1)
   read apal(j,2)
   read apal(j,3)
next j

for c=1 to 3
    gpal(1,c)=0
    gpal(2,c)=128
    gpal(3,c)=255
next c

bstart=15
astart=15

for a=0 to 15
    for b=0 to 15
        for c=1 to 3
            mixedpal(a,b,c)=int((apal(a,c)+apal(b,c))/2)
        next c
    next b
next a




'locate 5,1:print "Mixing Palettes..."

for a=0 to 15
    for b=0 to 15
        for c=0 to 15
            for d=0 to 15
                for i=1 to 3
                    mixpals(a,b,c,d,1,i)=int((apal(a,i)+apal(c,i))/2)
                    mixpals(a,b,c,d,2,i)=int((apal(a,i)+apal(d,i))/2)
                    mixpals(a,b,c,d,3,i)=int((apal(b,i)+apal(c,i))/2)
                    mixpals(a,b,c,d,4,i)=int((apal(b,i)+apal(d,i))/2)
                next i
            next d
        next c
    next b
next a

countme=0
while yostop<>999
    countme=countme+1
    read lbj
    if lbj<>999 then graphchar(lbj)=lbj
    if lbj=999 then yostop=999
wend

'for i=0 to 255
'  for j=0 to 7
'    for p=0 to 7
'      pset(p,j),charmap(i,p,j)*15
'    next p    
'  next j
'next i



gosub start

END: REM -- end of program

REM -----------------------------------
REM ---- load .BMP file subroutine ----
REM -----------------------------------
REM known bug: image not loaded properly when (XSIZEBMP MOD 4) <> 0

START:

B = 0
IPOS = 0
FRAME1$=SAVENAME$+".FR1"
FRAME2$=SAVENAME$+".FR2"
OUTPUTNAME$=SAVENAME$+".ASM"
MAKEFILE$="make.bat"

OPEN "I", 1, FILENAME$
OPEN "O", 2, FRAME1$
open "O", 3, FRAME2$
OPEN "O", 4, outputname$
open "O", 5, makefile$

FOR i = 0 TO 117
   B = ASC(INPUT$(1, #1))
   IF (IPOS = 0) AND (B <> 66) THEN GOTO NOTBMP: REM no header "B"
   IF (IPOS = 1) AND (B <> 77) THEN GOTO NOTBMP: REM no header "M"
   IF (IPOS = 18) THEN XSIZEBMP = B
   IF (IPOS = 19) THEN XSIZEBMP = XSIZEBMP + (B * 256)
   IF (IPOS = 22) THEN YSIZEBMP = B
   IF (IPOS = 23) THEN YSIZEBMP = YSIZEBMP + (B * 256)
   'IF (IPOS = 28) AND (B <> 4) THEN GOTO NOT16: REM not 4 bits, 16 color
   IPOS = IPOS + 1
NEXT i
IF (XSIZEBMP <> 320 OR YSIZEBMP <> 192) THEN GOTO NOT8072: REM not right size
REM ---- pixels in .BMP are stored from bottom left to top right ----
xpos = 0
YPOS = YSIZEBMP - 1
LOCATE 2, 42: PRINT "Conversion in Process..."
LOCATE 3, 42: PRINT "Filename: "; right$(FILENAME$,8)
LOCATE 4, 42: PRINT "Output: "; right$(SAVENAME$,8)
bload filename$,@imgload(0)
put (0,1),imgload(0)

locate 5,42:
print "Dither? (Y/N):"
asker:
dt$=inkey$:if dt$<>"Y" and dt$<>"y" and dt$<>"N" and dt$<>"n" then goto asker
'print dt$
if dt$="y" or dt$="Y" then dither=1

locate 6,42:
print "Bloxel or Full Character Set? (B/F):"
asker2:
dt$=inkey$:if dt$<>"B" and dt$<>"b" and dt$<>"F" and dt$<>"f" then goto asker2
'print dt$
if dt$="b" or dt$="B" then bloxel=1

for y=1 to 192
    for x=1 to 320
      imagein(x,y,3)=imgload((y-1)*320+x) And 255
      imagein(x,y,2)=(imgload((y-1)*320+x) and 65280)\256
      imagein(x,y,1)=(imgload((y-1)*320+x) and 16711680)\65536
      
      imageinbak(x,y,3)=imagein(x,y,3)
      imageinbak(x,y,2)=imagein(x,y,2)
      imageinbak(x,y,1)=imagein(x,y,1)
      
      'locate 50,1
      'print imgload(y*320+x+1);" ";imagein(x,y,1);" ";imagein(x,y,2);" ";imagein(x,y,3);"               "
      'locate 2,50:print "ORIGS: ";rgb(imagein(x,y,1),imagein(x,y,2),imagein(x,y,3));"               "
      'input f$
    next x
next y

erase palcount

for y=1 to 192
    for x=1 to 320
      for c=1 to 3
          if imagein(x,y,c)>=255 then imagein(x,y,c)=255
          if imagein(x,y,c)<=0 then imagein(x,y,c)=0
      next c
      mindist=50000:minindi=5
            for a=0 to 15
                for b=0 to 15
                    'locate 12,42:print "g,h,m:";g;h;m
                    colordist=sqr((imagein(x,y,1)-mixedpal(a,b,1))^2+(imagein(x,y,2)-mixedpal(a,b,2))^2+(imagein(x,y,3)-mixedpal(a,b,3))^2)
                    'locate 13,42:print "colordist:";colordist
                    if colordist<mindist then 
                      mindist=colordist:mina=a:minb=b
                    end if
                next b
            next a
            
            rdist=imagein(x,y,1)-mixedpal(mina,minb,1)  ' calculate error in R dimension
            gdist=imagein(x,y,2)-mixedpal(mina,minb,2)  ' calculate error in G dimension
            bdist=imagein(x,y,3)-mixedpal(mina,minb,3)  ' calculate error in B dimension
            
            for c=1 to 3
                imagein(x,y,c)=mixedpal(mina,minb,c)
            next c
            pset(x,y+200),rgb(mixedpal(mina,minb,1),mixedpal(mina,minb,2),mixedpal(mina,minb,3))
            
            palcount(int((x-1)/8)+1,int((y-1)/8)+1,mina,minb)=palcount(int((x-1)/8)+1,int((y-1)/8)+1,mina,minb)+1
            'locate 13,42:print "palcount:";palcount(int((x-1)/8)+1,int((y-1)/8)+1,mina,minb);"   "
            'locate 14,42:print "x,y:";x;y;"    "
            'locate 15,42:print "col, row:";int((x-1)/8)+1;int((y-1)/8)+1;"    "

            
            if dither=1 then
    
                if x<320 then
                    imagein(x+1,y,1)=imagein(x+1,y,1)+(7/16)*rdist
                    imagein(x+1,y,2)=imagein(x+1,y,2)+(7/16)*gdist
                    imagein(x+1,y,3)=imagein(x+1,y,3)+(7/16)*bdist            
                end if
        
                if x<320 and y<192 then
                    imagein(x+1,y+1,1)=imagein(x+1,y+1,1)+(1/16)*rdist
                    imagein(x+1,y+1,2)=imagein(x+1,y+1,2)+(1/16)*gdist
                    imagein(x+1,y+1,3)=imagein(x+1,y+1,3)+(1/16)*bdist
                end if
        
                if y<192 then
                    imagein(x,y+1,1)=imagein(x,y+1,1)+(5/16)*rdist
                    imagein(x,y+1,2)=imagein(x,y+1,2)+(5/16)*gdist
                    imagein(x,y+1,3)=imagein(x,y+1,3)+(5/16)*bdist
                end if
        
                if x>1 and y<192 then
                    imagein(x-1,y+1,1)=imagein(x-1,y+1,1)+(3/16)*rdist
                    imagein(x-1,y+1,2)=imagein(x-1,y+1,2)+(3/16)*gdist
                    imagein(x-1,y+1,3)=imagein(x-1,y+1,3)+(3/16)*bdist            
                end if    
            end if
    next x
next y

'for y=1 to 24
'    for x=1 to 40
'      locate 55,1
'        for a=0 to 15
'            for b=0 to 15
'                if palcount(x,y,a,b)>0 then print "x,y,a,b,count:";x;y;a;b;palcount(x,y,a,b);"    "             
'            next b
'        next a
'        for nb=1 to 10
'            print "                              ";
'        next nb
'        input gh$
'    next x
'next y

for y=1 to 192 step 8
  for x=1 to 320 step 8
    col=(int(x-1)/8)+1
    row=(int(y-1)/8)+1
    'locate 55,1
     'for ta=0 to 15
      ' for tb=0 to 15
       '  if palcount(col,row,ta,tb)>0 then print "col,row,ta,tb,count:";col;row;ta;tb;palcount(col,row,ta,tb);"        "             
       'next tb
     'next ta
     'for nb=1 to 10
     '  print "                              ";
     'next nb
    minpaldist=500000000:maxa=16:maxb=16:maxc=16:maxd=16
    for a=0 to 15
        for b=0 to 15
            
            For c=0 to 15
               
                For d=0 to 15
                    paldist=0
                    for ta=0 to 15
                        for tb=0 to 15
                            miner=50000000:minc=5
                            if palcount(col,row,ta,tb)>0 then 
                                for j=1 to 4
                                    coldist = sqr((mixpals(a,b,c,d,j,1)-mixedpal(ta,tb,1))^2+(mixpals(a,b,c,d,j,2)-mixedpal(ta,tb,2))^2+(mixpals(a,b,c,d,j,3)-mixedpal(ta,tb,3))^2)
                                    if coldist<miner then miner=coldist:minc=j
                                next j
                                paldist=paldist+miner*palcount(col,row,ta,tb)
                                'locate 16,42:print "a,b,c,d:";a;b;c;d;"             "
                                'locate 17,42:print "miner:";miner;"              "
                                'locate 18,42:print "ta,tb:";ta;tb;"          "
                                'locate 19,42:print "paldist:";paldist;"          "
                            end if
                            
                        next tb
                    next ta
                    if paldist<minpaldist then
                        minpaldist=paldist
                        maxa=a:maxb=b:maxc=c:maxd=d

                    end if
                next d
            next c
        next b
    next a
    
    palout(col,row,1)=maxa
    palout(col,row,2)=maxb
    palout(col,row,3)=maxc
    palout(col,row,4)=maxd
    
    for g=0 to 7
        for h=0 to 7
          'locate 23,42:print "x,y,g,h:";x;y;g;h;"    "
          'locate 24,42:print "maxa,maxb,maxc,maxd:";maxa;maxb;maxc;maxd;"    "
          miner=500000:minc=5
          for j=1 to 4
            coldist = sqr((mixpals(maxa,maxb,maxc,maxd,j,1)-imagein(x+h,y+g,1))^2+(mixpals(maxa,maxb,maxc,maxd,j,2)-imagein(x+h,y+g,2))^2+(mixpals(maxa,maxb,maxc,maxd,j,3)-imagein(x+h,y+g,3))^2)
            if coldist<miner then miner=coldist:minc=j
          next j            
          'locate 21,42:print "r,g,b:";mixpals(maxa,maxb,maxc,maxd,minc,1);mixpals(maxa,maxb,maxc,maxd,minc,2);mixpals(maxa,maxb,maxc,maxd,minc,3);"     "  
          pset(x+h,y+g+400),rgb(mixpals(maxa,maxb,maxc,maxd,minc,1),mixpals(maxa,maxb,maxc,maxd,minc,2),mixpals(maxa,maxb,maxc,maxd,minc,3))
          for mmd=1 to 3
              imagein(x+h,y+g,mmd)=mixpals(maxa,maxb,maxc,maxd,minc,mmd) 
          next mmd
        next h
    next g
    

  next x
next y




LOCATE 9, 42: PRINT "Processing Array..."

   FOR y = 1 TO 192 STEP 8
     FOR X = 1 TO 320 STEP 8
        col=(int(x-1)/8)+1
        row=(int(y-1)/8)+1
        LOCATE 10, 42: PRINT "Col "; col; "   Row "; row

    

units = 255
tstart = 255
dstart = 255
mindistance=50000:mind=512:mint=512:chardist=0
    for t=0 to 511
       if bloxel =1 then
           if t=0 then
             t=159
             goto skippert               
           end if
           if t=192 then
                t=223
                goto skippert
           end if
           if t=256 then
             t=415
             goto skippert               
           end if
           if t=448 then
                t=479
                goto skippert
           end if
       end if
           

       for d=0 to 511
           if bloxel=1 then 
               if d=0 then
                    d=159
                    goto skippert               
               end if
               if d=192 then 
                    d=223
                    goto skipperd
               end if
               if d=256 then
                    d=415
                    goto skippert               
               end if
               if d=448 then 
                    d=479
                    goto skipperd
               end if
           end if

         totaldist=0
         chardist=0
         for g=0 to 7
           for h=0 to 7
              for c=1 to 3
                  if charmap(d,h,g)=1 and charmap(t,h,g)=1 then mixcharo(h,g,c)=int((apal(palout(col,row,1),c)+apal(palout(col,row,3),c))/2)
                  if charmap(d,h,g)=1 and charmap(t,h,g)=0 then mixcharo(h,g,c)=int((apal(palout(col,row,1),c)+apal(palout(col,row,4),c))/2)
                  if charmap(d,h,g)=0 and charmap(t,h,g)=1 then mixcharo(h,g,c)=int((apal(palout(col,row,2),c)+apal(palout(col,row,3),c))/2)
                  if charmap(d,h,g)=0 and charmap(t,h,g)=0 then mixcharo(h,g,c)=int((apal(palout(col,row,2),c)+apal(palout(col,row,4),c))/2)
              next c
              chardist=sqr((imagein(x+h,y+g,1)-mixcharo(h,g,1))^2+(imagein(x+h,y+g,2)-mixcharo(h,g,2))^2+(imagein(x+h,y+g,3)-mixcharo(h,g,3))^2)
              totaldist=totaldist+chardist
              'locate 12,42: print"t,d,g,h,chardist,matches: ";t;d;g;h;chardist;totaldist;"          "
              
           next h
         next g
         if totaldist<mindistance then mindistance=totaldist:mind=d:mint=t
         'locate 13,42:print "t,d,mindist,totdist:";mind;mint;mindistance;totaldist;"           " 
skipperd:
       next d
       'dstart=dstart-1:if dstart<=-1 then dstart=tstart-1
skippert:
    next t

    outchars(col,row,1)=mind
    outchars(col,row,2)=mint

    'locate 14,42:print "row,x:";row;x
    'locate 15,42:print "mind, mint:";mind;mint
    
    for g=0 to 7
        for h=0 to 7

            if charmap(mind,h,g)=1 then pset(x+h+350,y+g+200),rgb(apal(palout(col,row,1),1),apal(palout(col,row,1),2),apal(palout(col,row,1),3))
            if charmap(mind,h,g)=0 then pset(x+h+350,y+g+200),rgb(apal(palout(col,row,2),1),apal(palout(col,row,2),2),apal(palout(col,row,2),3))
            
            if charmap(mint,h,g)=1 then pset(x+h+350,y+g+400),rgb(apal(palout(col,row,3),1),apal(palout(col,row,3),2),apal(palout(col,row,3),3))
            if charmap(mint,h,g)=0 then pset(x+h+350,y+g+400),rgb(apal(palout(col,row,4),1),apal(palout(col,row,4),2),apal(palout(col,row,4),3))
            
            if charmap(mind,h,g)=1 and charmap(mint,h,g)=1 then pset(x+h+350,y+g+600),rgb((apal(palout(col,row,1),1)+apal(palout(col,row,3),1))/2,(apal(palout(col,row,1),2)+apal(palout(col,row,3),2))/2,(apal(palout(col,row,1),3)+apal(palout(col,row,3),3))/2)
            if charmap(mind,h,g)=0 and charmap(mint,h,g)=0 then pset(x+h+350,y+g+600),rgb((apal(palout(col,row,2),1)+apal(palout(col,row,4),1))/2,(apal(palout(col,row,2),2)+apal(palout(col,row,4),2))/2,(apal(palout(col,row,2),3)+apal(palout(col,row,4),3))/2)
            
            if charmap(mind,h,g)=1 and charmap(mint,h,g)=0 then pset(x+h+350,y+g+600),rgb((apal(palout(col,row,1),1)+apal(palout(col,row,4),1))/2,(apal(palout(col,row,1),2)+apal(palout(col,row,4),2))/2,(apal(palout(col,row,1),3)+apal(palout(col,row,4),3))/2)
            if charmap(mind,h,g)=0 and charmap(mint,h,g)=1 then pset(x+h+350,y+g+600),rgb((apal(palout(col,row,2),1)+apal(palout(col,row,3),1))/2,(apal(palout(col,row,2),2)+apal(palout(col,row,3),2))/2,(apal(palout(col,row,2),3)+apal(palout(col,row,3),3))/2)
            
        next h
    next g
     


    
            
       NEXT X
 NEXT row

CLOSE #1

print #2,"FrameOneChar:"
print #2,""
print #2,"   .db ";

print #3,"FrameTwoChar:"
print #3,""
print #3,"   .db ";

for y=1 to 192 step 8
    for x=1 to 320 step 8
        col=(int(x-1)/8)+1
        row=(int(y-1)/8)+1 
        if col<40 then 
            if outchars(col,row,1)<=255 then print #2,str$(outchars(col,row,1));","; else print #2,str$(outchars(col,row,1)-256);",";
        end if
        if col=40 then 
            if outchars(col,row,1)<=255 then print #2,str$(outchars(col,row,1)) else print #2,str$(outchars(col,row,1)-256)
            print #2,"   .db ";
        end if
        if col<40 then 
            if outchars(col,row,2)<=255 then print #3,str$(outchars(col,row,2));","; else print #3,str$(outchars(col,row,2)-256);",";
        end if
        if col=40 then 
            if outchars(col,row,2)<=255 then print #3,str$(outchars(col,row,2)) else print #3,str$(outchars(col,row,2)-256)
            print #3,"   .db ";
        end if
        
    next x
    'print #2,""
    'print #3,""
next y

print #2,""
print #2,"FrameOneCol:"
print #2,""
print #2,"   .db ";

print #3,""
print #3,"FrameTwoCol:"
print #3,""
print #3,"   .db ";


for y=1 to 192 step 8
    for x=1 to 320 step 8
        col=(int(x-1)/8)+1
        row=(int(y-1)/8)+1 
        'locate 16,1:print "col,row:";col;row
        'input ghgh$
        if outchars(col,row,1)<=255 then 
            color1=collok(palout(col,row,1))*16+collok(palout(col,row,2))
        else
            color1=collok(palout(col,row,2))*16+collok(palout(col,row,1))
        end if
        
        if outchars(col,row,2)<=255 then
            color2=collok(palout(col,row,3))*16+collok(palout(col,row,4))
        else
            color2=collok(palout(col,row,4))*16+collok(palout(col,row,3))
        end if
    
        if col<40 then print #2,str$(color1);",";
        if col=40 then print #2,str$(color1):print #2,"   .db ";
        
        if col<40 then print #3,str$(color2);",";
        if col=40 then print #3,str$(color2):print #3,"   .db ";
        
    next x
    'print #2,""
    'print #3,""
next y

PRINT #4,"; Displays an Image Using 136 Flicker Colors and 65,536 Flicker Blocks"
PRINT #4,"; Use tasm to compile"
PRINT #4,";"
PRINT #4,".org $E000			; Start Program at Memloc $E010"
print #4,""
print #4,".db $b6, $b7, $24, $2a, $8d, $9c, $42, $b0"
print #4,".db $53, $6c, $90, $64, $89, $a8, $f9, $70"
print #4,""
PRINT #4,""
PRINT #4,"main:"	
PRINT #4,""
PRINT #4,"delayb:"
PRINT #4,"		ld	c,1"
PRINT #4,"		call waittof"
PRINT #4,"      call ViewFr1"
PRINT #4,""	
PRINT #4,"delaya:"
PRINT #4,"		ld	c,1"
PRINT #4,"		call waittof"
PRINT #4,"      call ViewFr2"
PRINT #4,""
PRINT #4,"        jp main                 ; Repeat"
PRINT #4,""
PRINT #4,""
PRINT #4,"waittof:"
PRINT #4,"	push	af"
PRINT #4,"	push	bc"
PRINT #4,""
PRINT #4,"	ld	b,c"
PRINT #4,""
PRINT #4,"    ld  c,253"
PRINT #4,"_lop1"
PRINT #4,"    in  a,(c)"
PRINT #4,"    bit 0,a"
PRINT #4,"    jr  z,_invblanka"
PRINT #4,"    jr  nz,_lop1"
PRINT #4,"_invblanka"
PRINT #4,"    in  a,(c)"
PRINT #4,"    bit 0,a"
PRINT #4,"    jr  z,_invblanka"
PRINT #4,""
PRINT #4,"	dec		b"
PRINT #4,"	jr		nz,_lop1"
PRINT #4,"	pop		bc"
PRINT #4,"	pop		af"
PRINT #4,"	ret"
PRINT #4,""
PRINT #4,"ViewFr1:"
PRINT #4,"	ld  de, 12328		; Set Memory Location to Character Video"
PRINT #4,"	ld hl, FrameOneChar		; Set HL to FrameOneChar Memory Location"
PRINT #4,"	ld bc, 960			; 960 Bytes of Data"
PRINT #4,"	ldir			; write 960 bytes from FrameOneChar to screen"
PRINT #4,"	ld de, 13352		; Set Memory Location to Color Video"
PRINT #4,"	ld hl, FrameOneCol		; Set HL to FrameOneCol Memory Location"
PRINT #4,"	ld bc, 960			; 960 Bytes of Data"
PRINT #4,"	ldir			; write 960 bytes from FrameOneCol to screen"
PRINT #4,"	ret			; return to main program"
PRINT #4,""	
PRINT #4,"ViewFr2:"
PRINT #4,"	ld  de, 12328		; Set Memory Location to Character Video"
PRINT #4,"	ld hl, FrameTwoChar		; Set HL to FrameTwoChar Memory Location"
PRINT #4,"	ld bc, 960			; 960 Bytes of Data"
PRINT #4,"	ldir			; write 960 bytes from FrameTwoChar to screen"
PRINT #4,"	ld de, 13352		; Set Memory Location to Color Video"
PRINT #4,"	ld hl, FrameTwoCol		; Set HL to FrameTwoCol Memory Location"
PRINT #4,"	ld bc, 960			; 960 Bytes of Data"
PRINT #4,"	ldir			; write 960 bytes from FrameTwoCol to screen"
PRINT #4,"	ret			; return to main program"

oute$ = "#include "+savename$+".FR1"
outf$ = "#include "+savename$+".FR2"

print #4, oute$
print #4, outf$
PRINT #4,""
PRINT #4,".END"

outg$="tasm -80 -b "+outputname$+" >tasmout.txt"
outh$="copy /b carthead.bin+"+savename$+".obj "+savename$+".bin"

print #5,outg$
print #5,outh$

close #2
close #3
close #4
close #5

locate 102,24:print "DONE! Press a key to exit."
input f$
RETURN

REM -----------------
REM ---- errors  ----
REM -----------------

NOTBMP:
  PRINT "Not a bitmap file, error reading header, "; FILENAME$
END

NOT16:
  PRINT "Not a 16 color bitmap file, "; FILENAME$; ", expected 4 found "; B
END

NOT8072:
  PRINT "BMP Must be 80 x 72"
END

REM Color Distance Lookup Table:  16x16 Array

DATA 0,138,203,227,163,263,351,320,68,215,239,265,239,337,330,442
DATA 138,0,199,153,146,144,293,226,93,92,258,184,217,215,308,341
DATA 203,199,0,111,218,267,223,207,156,231,63,132,284,336,220,311
DATA 227,153,111,0,228,205,228,157,170,144,169,37,294,266,263,261
DATA 163,146,218,228,0,162,240,228,122,230,260,256,81,228,219,339
DATA 263,144,267,205,162,0,235,160,207,162,325,217,182,76,273,250
DATA 351,293,223,228,240,235,0,113,288,321,244,222,244,265,90,156
DATA 320,226,207,157,228,160,113,0,253,228,252,146,252,189,187,121
DATA 68,93,156,170,122,207,288,253,0,174,203,206,203,283,277,374
DATA 215,92,231,144,230,162,321,228,174,0,293,163,293,215,357,328
DATA 239,258,63,169,260,325,244,252,203,293,0,184,321,393,227,345
DATA 265,184,132,37,256,217,222,146,206,163,184,0,316,270,268,238
DATA 239,217,284,294,81,182,244,252,203,293,321,316,0,227,218,345
DATA 337,215,336,266,228,76,265,189,283,215,393,270,227,0,315,245
DATA 330,308,220,263,219,273,90,187,277,357,227,268,218,315,0,246
DATA 442,341,311,261,339,250,156,121,374,328,345,238,345,245,246,0

DATA 0,11,13,9,14,10,12,8,15,4,2,6,1,5,3,7
 
DATA "0011110000100000001000000111100000100000011000001010110000000000"
DATA "0100010001001000010100000010110001000100000010000001110000000000"
DATA "0100010001001000010100000010110001010100000111000000010000000000"
DATA "0110010000101000010100000010110001010100000111000000010000000000"
DATA "0000000000010000000000000111110000000000000100000000000000000000"
DATA "0011110001000010100110011010000110100001100110010100001000111100"
DATA "0000000000000100000000101111111111111111000000100000010000000000"
DATA "0000000000100000010000001111111111111111010000000010000000000000"
DATA "0001100000111100010110100001100000011000000110000001100000011000"
DATA "0001100000011000000110000001100000011000010110100011110000011000"
DATA "0000111100000111000011110001110100111000011100000010000000000000"
DATA "0000000000000100000011100001110010111000111100001110000011110000"
DATA "0000000000100000011100000011100000011101000011110000011100001111"
DATA "1111000011100000111100001011100000011100000011100000010000000000"
DATA "0000000000111100001111000000000001111110111111111111111111111111"
DATA "1111110011111100001111000011000000110000001100000011000000110000"
DATA "1111111100111100001111000011110000111100000000000000000000000000"
DATA "0111111101111111011110000001100000011000000110000001100000011000"
DATA "0011110000111100001111000011110000111100001111000011110000111100"
DATA "0000000000111100001111000000000001111110111111111011110111011011"
DATA "0111111000111100011001100110011011100111110000111100001111000011"
DATA "0000000000111000001111000000000000111000011110000111110001111111"
DATA "0111110000111110000110110001111000011100000110000011100000111000"
DATA "0000000000111000001111000000000000111001011110011101111111011100"
DATA "0111110000111111000111110011101111110011110000111000000000000000"
DATA "0001100000111100011001100010010011100111101111011001100111011011"
DATA "0000000000000000000000000000000000001111000011110000111100001111"
DATA "0000111100001111000011110000111100000000000000000000000000000000"
DATA "0000000000000000000000000000000011110000111100001111000011110000"
DATA "1111000011110000111100001111000000000000000000000000000000000000"
DATA "1111000011110000111100001111000000001111000011110000111100001111"
DATA "0000000000000000000000000000000011111111111111111111111111111111"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "0001000000010000000100000001000000010000000000000001000000000000"
DATA "0010100000101000001010000000000000000000000000000000000000000000"
DATA "0010100000101000011111000010100001111100001010000010100000000000"
DATA "0001000000111100010100000011100000010100011110000001000000000000"
DATA "0110000001100100000010000001000000100000010011000000110000000000"
DATA "0010000001010000010100000010000001010100010010000011010000000000"
DATA "0000100000001000000100000000000000000000000000000000000000000000"
DATA "0001000000100000010000000100000001000000001000000001000000000000"
DATA "0001000000001000000001000000010000000100000010000001000000000000"
DATA "0001000001010100001110000001000000111000010101000001000000000000"
DATA "0000000000010000000100000111110000010000000100000000000000000000"
DATA "0000000000000000000000000000000000010000000100000010000000000000"
DATA "0000000000000000000000000111110000000000000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000001000000000000"
DATA "0000000000000100000010000001000000100000010000000000000000000000"
DATA "0011100001000100010011000101010001100100010001000011100000000000"
DATA "0001000000110000000100000001000000010000000100000011100000000000"
DATA "0011100001000100000001000001100000100000010000000111110000000000"
DATA "0111110000000100000010000001100000000100010001000011100000000000"
DATA "0000100000011000001010000100100001111000000010000000100000000000"
DATA "0111110001000000011110000000010000000100010001000011100000000000"
DATA "0001110000100000010000000111100001000100010001000011100000000000"
DATA "0111110000000100000010000001000000100000001000000010000000000000"
DATA "0011100001000100010001000011100001000100010001000011100000000000"
DATA "0011100001000100010001000011110000000100000010000111000000000000"
DATA "0000000000000000000100000000000000010000000000000000000000000000"
DATA "0000000000000000000100000000000000010000000100000010000000000000"
DATA "0000100000010000001000000100000000100000000100000000100000000000"
DATA "0000000000000000011111000000000001111100000000000000000000000000"
DATA "0010000000010000000010000000010000001000000100000010000000000000"
DATA "0011100001000100000010000001000000010000000000000001000000000000"
DATA "0011100001000100010101000101110001011000010000000011100000000000"
DATA "0001000000101000010001000100010001111100010001000100010000000000"
DATA "0111100001000100010001000111100001000100010001000111100000000000"
DATA "0011100001000100010000000100000001000000010001000011100000000000"
DATA "0111100001000100010001000100010001000100010001000111100000000000"
DATA "0111110001000000010000000111100001000000010000000111110000000000"
DATA "0111110001000000010000000111100001000000010000000100000000000000"
DATA "0011110001000000010000000100000001001100010001000011110000000000"
DATA "0100010001000100010001000111110001000100010001000100010000000000"
DATA "0011100000010000000100000001000000010000000100000011100000000000"
DATA "0000010000000100000001000000010000000100010001000011100000000000"
DATA "0100010001001000010100000110000001010000010010000100010000000000"
DATA "0100000001000000010000000100000001000000010000000111110000000000"
DATA "0100010001101100010101000101010001000100010001000100010000000000"
DATA "0100010001000100011001000101010001001100010001000100010000000000"
DATA "0011100001000100010001000100010001000100010001000011100000000000"
DATA "0111100001000100010001000111100001000000010000000100000000000000"
DATA "0011100001000100010001000100010001010100010010000011010000000000"
DATA "0111100001000100010001000111100001010000010010000100010000000000"
DATA "0011100001000100010000000011100000000100010001000011100000000000"
DATA "0111110000010000000100000001000000010000000100000001000000000000"
DATA "0100010001000100010001000100010001000100010001000011100000000000"
DATA "0100010001000100010001000100010001000100001010000001000000000000"
DATA "0100010001000100010001000101010001010100011011000100010000000000"
DATA "0100010001000100001010000001000000101000010001000100010000000000"
DATA "0100010001000100001010000001000000010000000100000001000000000000"
DATA "0111110000000100000010000001000000100000010000000111110000000000"
DATA "0111110001100000011000000110000001100000011000000111110000000000"
DATA "0000000001000000001000000001000000001000000001000000000000000000"
DATA "0111110000001100000011000000110000001100000011000111110000000000"
DATA "0000000000000000000100000010100001000100000000000000000000000000"
DATA "0000000000000000000000000000000000000000000000000111110000000000"
DATA "0010000000100000000100000000000000000000000000000000000000000000"
DATA "0000000000000000001101000100110001000100010011000011010000000000"
DATA "0100000001000000010110000110010001000100011001000101100000000000"
DATA "0000000000000000000111000010000000100000001000000001110000000000"
DATA "0000010000000100001101000100110001000100010011000011010000000000"
DATA "0000000000000000001110000100010001111100010000000011100000000000"
DATA "0000100000010000000100000011100000010000000100000001000000000000"
DATA "0000000000000000001101000100110001000100001111000000010000000000"
DATA "0100000001000000011110000100010001000100010001000100010000000000"
DATA "0001000000000000001100000001000000010000000100000011100000000000"
DATA "0000100000000000000010000000100000001000000010000000100000000000"
DATA "0100000001000000010010000101000001110000010010000100010000000000"
DATA "0011000000010000000100000001000000010000000100000011100000000000"
DATA "0000000000000000011011000101001001010010010100100101001000000000"
DATA "0000000000000000011110000100010001000100010001000100010000000000"
DATA "0000000000000000001110000100010001000100010001000011100000000000"
DATA "0000000000000000010110000110010001000100011001000101100001000000"
DATA "0000000000000000001101000100110001000100010011000011010000000110"
DATA "0000000000000000010110000110000001000000010000000100000000000000"
DATA "0000000000000000001111000100000000111000000001000111100000000000"
DATA "0001000000010000011111000001000000010000000100000001000000000000"
DATA "0000000000000000010001000100010001000100010001000011110000000000"
DATA "0000000000000000010001000100010000101000001010000001000000000000"
DATA "0000000000000000010100100101001001010010010100100010110000000000"
DATA "0000000000000000010001000010100000010000001010000100010000000000"
DATA "0000000000000000001001000010010000100100001111000000010000111000"
DATA "0000000000000000011111000000100000010000001000000111110000000000"
DATA "0000110000010000000100000010000000010000000100000000110000000000"
DATA "0001000000010000000100000000000000010000000100000001000000000000"
DATA "0110000000010000000100000000100000010000000100000110000000000000"
DATA "0000000000000000000001000011100001000000000000000000000000000000"
DATA "1111111111111111111111111111111111111111111111111111111111111111"
DATA "0000000011111111111111111111111111111111111111111111111111111111"
DATA "1000000010000000100000001000000010000000100000001000000010000000"
DATA "0000000000011100001111000000000000011100000111100011111011111110"
DATA "0011111001111100110110000111100000111000000110000001110000011100"
DATA "0000000000000000000000000000000010101010010101011010101001010101"
DATA "1010000001010000101000000101000010100000010100001010000001010000"
DATA "1010101001010101101010100101010110101010010101011010101001010101"
DATA "0000000000011000001111000111111001111110001111000001100000000000"
DATA "0000000000000000000000000000000000000000000000001111111111111111"
DATA "0000000000000000111111111111111111111111111111111111111111111111"
DATA "0001100000011000001111000111111011111111110110110001100000111100"
DATA "0011110000011000110110111111111101111110001111000001100000011000"
DATA "0000000000011100001111000000000010011100100111101111101100111011"
DATA "0011111011111100111110001101110011001111110000110000000100000000"
DATA "1100000011110000111111001111111111111111111111001111000011000000"
DATA "0001100000011000001111000011110001111110011111101111111111111111"
DATA "0000000000000000000000000000000000000000000000000000000011111111"
DATA "1111111011111110111111101111111011111110111111101111111011111110"
DATA "0011110001010010001111001000000010111100111111110011110100111101"
DATA "0011110001001010001111000000000100111101111111111011110010111100"
DATA "1010101001010101101010100101010000000000000000000000000000000000"
DATA "0000101000000101000010100000010100001010000001010000101000000101"
DATA "0011110001111110111111111111111111111111111111110111111000111100"
DATA "1100000011000000110000001100000011000000110000001100000011000000"
DATA "1110000011100000111000001110000011100000111000001110000011100000"
DATA "1111000011110000111100001111000011110000111100001111000011110000"
DATA "0011000000111000100111001111111111111111100111000011100000110000"
DATA "0000110000011100001110011111111111111111001110010001110000001100"
DATA "0000000001100110011111100100001011000011111111110001100000000000"
DATA "0000000000011000111111111100001101000010011111100110011000000000"
DATA "0000001100001111001111111111111111111111001111110000111100000011"
DATA "1111111111111111011111100111111000111100001111000001100000011000"
DATA "0000000000000000000000000000000000000000000000000000000000000000"
DATA "1111000011110000111100000000000000000000000000000000000000000000"
DATA "0000111100001111000011110000000000000000000000000000000000000000"
DATA "1111111111111111111111110000000000000000000000000000000000000000"
DATA "0000000000000000000000001111000011110000000000000000000000000000"
DATA "1111000011110000111100001111000011110000000000000000000000000000"
DATA "0000111100001111000011111111000011110000000000000000000000000000"
DATA "1111111111111111111111111111000011110000000000000000000000000000"
DATA "0000000000000000000000000000111100001111000000000000000000000000"
DATA "1111000011110000111100000000111100001111000000000000000000000000"
DATA "0000111100001111000011110000111100001111000000000000000000000000"
DATA "1111111111111111111111110000111100001111000000000000000000000000"
DATA "0000000000000000000000001111111111111111000000000000000000000000"
DATA "1111000011110000111100001111111111111111000000000000000000000000"
DATA "0000111100001111000011111111111111111111000000000000000000000000"
DATA "1111111111111111111111111111111111111111000000000000000000000000"
DATA "0000000000000000000000000000000000000000111100001111000011110000"
DATA "1111000011110000111100000000000000000000111100001111000011110000"
DATA "0000111100001111000011110000000000000000111100001111000011110000"
DATA "1111111111111111111111110000000000000000111100001111000011110000"
DATA "0000000000000000000000001111000011110000111100001111000011110000"
DATA "1111000011110000111100001111000011110000111100001111000011110000"
DATA "0000111100001111000011111111000011110000111100001111000011110000"
DATA "1111111111111111111111111111000011110000111100001111000011110000"
DATA "0000000000000000000000000000111100001111111100001111000011110000"
DATA "1111000011110000111100000000111100001111111100001111000011110000"
DATA "0000111100001111000011110000111100001111111100001111000011110000"
DATA "1111111111111111111111110000111100001111111100001111000011110000"
DATA "0000000000000000000000001111111111111111111100001111000011110000"
DATA "1111000011110000111100001111111111111111111100001111000011110000"
DATA "0000111100001111000011111111111111111111111100001111000011110000"
DATA "1111111111111111111111111111111111110000111100001111000011110000"
DATA "0000000100000011000001110000111100011111001111110111111111111111"
DATA "1000000011000000111000001111000011111000111111001111111011111111"
DATA "1111111111111111011111100011110000000000000000000000000000000000"
DATA "1111110011111100111111001111110011111100111111001111110011111100"
DATA "0000000000000000001111000011110000111100001111000000000000000000"
DATA "0001100000111100011111101111111111111111011111100011110000011000"
DATA "0000000000000000000000000001100000011000000000000000000000000000"
DATA "0000111100001111000001110000001100000000000000000000000000000000"
DATA "0001100000011000000110001111111111111111000110000001100000011000"
DATA "0000000000000000000000000000000011000000111000001111000011110000"
DATA "0000000100000010000001000000100000010000001000000100000010000000"
DATA "0000001100000111000011110000111100001111000011110000011100000011"
DATA "0001100000011000000110001111111111111111000000000000000000000000"
DATA "0001100000011000000110000001111100011111000110000001100000011000"
DATA "0000000000000000000000001111100011111000000110000001100000011000"
DATA "0001100000011000000110000001111100011111000000000000000000000000"
DATA "0000100100100000000001001000000000010001010000000000100000000010"
DATA "0101001001000100001011011100010000010001101101000010001101001010"
DATA "0000000000000000000000000000000000111100011111101111111111111111"
DATA "0000000000010000001011000011101001011100001101000000010000000000"
DATA "0110011011111111111111111111111101111110001111000001100000011000"
DATA "0001100000111100000110000100001011100111010000100001100000111100"
DATA "0001100000011000000110000001100000011000000110000001100000011000"
DATA "0000000000000000000000000000000000000011000001110001111100011111"
DATA "1000000101000010001001000001100000011000001001000100001010000001"
DATA "1111000011110000111000001100000000000000000000000000000000000000"
DATA "1000000001000000001000000001000000001000000001000000001000000001"
DATA "1100000011100000111100001111000011110000111100001110000011000000"
DATA "0000000000000000000000001111111111111111000110000001100000011000"
DATA "0001100000011000000110001111100011111000000110000001100000011000"
DATA "0000000000000000000000000001111100011111000110000001100000011000"
DATA "0001100000011000000110001111100011111000000000000000000000000000"
DATA "0000000000000000000000000000000000001111000011110000111100001111"
DATA "1111000011110000111100000000000000000000000011110000111100001111"
DATA "0000111100001111000011110000000000000000000011110000111100001111"
DATA "1111111111111111111111110000000000000000000011110000111100001111"
DATA "0000000000000000000000001111000011110000000011110000111100001111"
DATA "1111000011110000111100001111000011110000000011110000111100001111"
DATA "0000111100001111000011111111000011110000000011110000111100001111"
DATA "1111111111111111111111111111000011110000000011110000111100001111"
DATA "0000000000000000000000000000111100001111000011110000111100001111"
DATA "1111000011110000111100000000111100001111000011110000111100001111"
DATA "0000111100001111000011110000111100001111000011110000111100001111"
DATA "1111111111111111111111110000111100001111000011110000111100001111"
DATA "0000000000000000000000001111111111111111000011110000111100001111"
DATA "1111000011110000111100001111111111111111000011110000111100001111"
DATA "0000111100001111000011111111111111111111000011110000111100001111"
DATA "1111111111111111111111111111111111111111000011110000111100001111"
DATA "0000000000000000000000000000000000000000111111111111111111111111"
DATA "1111000011110000111100000000000000000000111111111111111111111111"
DATA "0000111100001111000011110000000000000000111111111111111111111111"
DATA "1111111111111111111111110000000000000000111111111111111111111111"
DATA "0000000000000000000000001111000011110000111111111111111111111111"
DATA "1111000011110000111100001111000011110000111111111111111111111111"
DATA "0000111100001111000011111111000011110000111111111111111111111111"
DATA "1111111111111111111111111111000011110000111111111111111111111111"
DATA "0000000000000000000000000000111100001111111111111111111111111111"
DATA "1111000011110000111100000000111100001111111111111111111111111111"
DATA "0000111100001111000011110000111100001111111111111111111111111111"
DATA "1111111111111111111111110000111100001111111111111111111111111111"
DATA "0000000000000000000000001111111111111111111111111111111111111111"
DATA "1111000011110000111100001111111111111111111111111111111111111111"
DATA "0000111100001111000011111111111111111111111111111111111111111111"
DATA "1111111111111111111111111111111111111111111111111111111111111111"

DATA 0,0,0
DATA 54,11,126
DATA 25,194,54
DATA 32,159,159
DATA 159,25,25
DATA 185,25,185
DATA 238,238,101
DATA 185,185,185
DATA 39,39,39
DATA 25,25,212
DATA 11,238,11
DATA 39,185,185
DATA 238,11,11
DATA 238,11,238
DATA 238,229,11
DATA 255,255,255

DATA 15,133,163,183,203,226,246
DATA 16,134,164,184,204,227,247
DATA 17,135,165,185,205,228,248
DATA 18,136,166,186,206,229,249
DATA 26,137,167,187,207,230,250
DATA 27,142,168,188,208,231,251
DATA 28,143,169,189,209,232,252
DATA 29,144,170,190,210,233,253
DATA 30,145,171,191,214,234,254
DATA 31,148,172,192,215,235
DATA 46,149,173,193,216,236
DATA 58,150,174,194,217,237
DATA 61,151,175,195,218,238
DATA 92,152,176,196,219,239
DATA 95,153,177,197,220,240
DATA 124,158,178,198,221,241
DATA 127,159,179,199,222,242
DATA 128,160,180,200,223,243
DATA 129,161,181,201,224,244
DATA 132,162,182,202,225,245,999



